//*****************************************
//  ATmega48 8x8 dot matrix LED Displaypin)
//   UWlgɂ

//   q[Yf[^́@`FbŃurohdmv
//   @@@@@@@@@uannsryv́uBoot Flash size=4096 words Boot Address=$7000v
//   @@@@@@@@@uanckdudkv́uBrown-out detection at VCC=2.7Vv
//   @@@@@@@@@urtsQbjrdkv́uInt Rc Osc.8MHz,Start-up time:6CK+64msv
//
// File Name:ad_conv.c
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/17 Modify for six IN-16 clock Taishi
//  2022/08/23 Modify for pr_six_in17_clock2 Taishi
//  2022/10/24 modify taishi for nega48 & Character Mode only, Anode Common only
//*****************************************
#include				<avr/io.h>

#include	"mega48_8x8_dot_h.h"
#include	"ad_conv_h.h"

static	int				ad7_data[N_of_AD_data];
int						ad7_ave;
static	unsigned char	ad7_count;

// **********************************************************
// ************************* A/D 7 **************************
// **********************************************************

//*****************************************
// A/D 7 Initial
// @荞ݕs̏ԂŌĂ΂Ƃ
//*****************************************
void	ad7_init(void)
{
	unsigned char	i;

	ad7_count = 0;
	for(i = 0; i < N_of_AD_data; i++){
		ad7_data[i] = 0;
	}
	ad7_ave = 0;


	ADMUX = ( (0 << REFS1) | (1 << REFS0) | (1 << MUX2) | (1 << MUX1) | (1 << MUX0) );		// `ubbdgp, EASelect ADC6
	ADCSRA = ( (1 << ADEN) | (1 << ADSC) | (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0) );	// A/D, A/DϊJn, CK/128=8MHz/128=62.5kHz(16uS) --> 208uS

}
//*****************************************
// A/D 7 close
//*****************************************
void	ad7_close(void)
{
	ADCSRA = 0;																				// A/Ds
}
//*****************************************
// A/D 7 Set A/D data to Data Buffer
//  ϊIĂȂ́@Ȃ
//*****************************************
void	ad7_set_data(void)
{
	if( (ADCSRA & (1 << ADIF)) != 0){								// `^cϊ
		ADCSRA |= (1 << ADIF);										// `^cϊtO폜
		ad7_data[ad7_count] = ADCW;
		ad7_count++;
		ad7_count &= (N_of_AD_data - 1);
		ADCSRA |= (1 << ADSC);										// A/DϊJn
	}
}
//*****************************************
// A/D 7 Get A/D data
//  obt@ɓĂf[^𕽋ςĎ擾
//*****************************************
unsigned int	ad7_get_data(void)
{
	unsigned char	i;
	unsigned int	sum;

	sum = 0;
	for(i = 0; i < N_of_AD_data; i++){						// obt@Sđ
		sum += ad7_data[i];
	}

	sum /= N_of_AD_data;									// f[^Ŋĕϒlɂ

	return(sum);
}
