//*******************************************************
//  ATmega48 8x8 dot matrix LED Display
//
//  file name: set_8x8_dot.c
//
//
//  2022/11/29  New(TAB4)	taishi for nega48 & Character Mode only, Anode Common only
//*******************************************************

#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"mega48_8x8_dot_h.h"
#include	"eep_dat_h.h"
#include	"timer_h.h"
#include	"port_bit_h.h"
#include	"uart_h.h"
#include	"disp_8x8_dot_h.h"

// *****************************
// A|̐ݒ菈
// *****************************
static	void	setpro_mirror_touritu(void)
{
	unsigned char	n;
	unsigned char	blink=0;
	unsigned char	uc=0;

	tim_10ms_blink = 0;										// 500mS Ԋu
	tim_1s_next = 5;										// 5S Ԋu
	n = mirror_touritu;
	asc_to_dotmatrix('F',n,0);								// AXL[hbg}gbNXf[^ɕϊ

	while(1){
		if(tim_10ms_blink == 0){
			tim_10ms_blink = 50;							// 500mS Ԋu
			blink ^= 1;
			if(blink == 0){
				asc_to_dotmatrix(' ',0,n);					// AXL[hbg}gbNXf[^ɕϊiXy[Xj
			}else{
				asc_to_dotmatrix('F',0,n);					// AXL[hbg}gbNXf[^ɕϊij
			}
		}

		if(tim_1s_next == 0){
			tim_1s_next = 5;								// 5S Ԋu
			if(uc & SW1_ON){								// XCb`͉Ă
				;											// l͂̂܂
			}else{
				n++;										//  ̐l
				if(3 < n){
					n = 0;
				}
				asc_to_dotmatrix('F',0,n);					// AXL[hbg}gbNXf[^ɕϊij
				blink = 1;
			}
		}

		uc = get_action_sw();								// XCb`̏
		if(uc & SW1_ON_NOW){								// ꂽ
			led_ds2_on();									// LED2 ON
		}
		if(uc & SW1_OFF_SHORT){								// Zꂽ
			led_ds2_off();
			break;
		}else if(uc & SW1_OFF_LONG){						// ꂽ
			asc_to_dotmatrix('F',0,n);						// AXL[hbg}gbNXf[^ɕϊij
			if(mirror_touritu != n){						// A|ύX
				mirror_touritu = n;							// A|L

				cli();
				write_eep_mirror_touritu(mirror_touritu);	// ddoqnl A| 
				sei();										// 荞݉
			}
			led_ds1_off();
			break;
		}

		set_bright();											// 邳߂
	}
}
// *****************************
// El̐ݒ菈
// *****************************
static	void	setpro_right_side_no(void)
{
	unsigned char	n;
	unsigned char	blink=0;
	unsigned char	uc=0;

	tim_10ms_blink = 0;										// 500mS Ԋu
	tim_1s_next = 5;										// 5S Ԋu
	n = right_side_no;
	asc_to_dotmatrix('8',n,0);								// AXL[hbg}gbNXf[^ɕϊ

	while(1){
		if(tim_10ms_blink == 0){
			tim_10ms_blink = 50;							// 500mS Ԋu
			blink ^= 1;
			if(blink == 0){
				asc_to_dotmatrix(' ',n,0);					// AXL[hbg}gbNXf[^ɕϊiXy[Xj
			}else{
				asc_to_dotmatrix('8',n,0);					// AXL[hbg}gbNXf[^ɕϊij
			}
		}

		if(tim_1s_next == 0){
			tim_1s_next = 5;								// 5S Ԋu
			if(uc & SW1_ON){								// XCb`͉Ă
				;											// l͂̂܂
			}else{
				n++;										//  ̐l
				if(3 < n){
					n = 0;
				}
				asc_to_dotmatrix('8',n,0);					// AXL[hbg}gbNXf[^ɕϊij
				blink = 1;
			}
		}

		uc = get_action_sw();								// XCb`̏
		if(uc & SW1_ON_NOW){								// ꂽ
			led_ds2_on();									// LED2 ON
		}
		if(uc & SW1_OFF_SHORT){								// Zꂽ
			led_ds2_off();
			break;
		}else if(uc & SW1_OFF_LONG){						// ꂽ
			asc_to_dotmatrix('8',n,0);						// AXL[hbg}gbNXf[^ɕϊij
			if(right_side_no != n){							// ElύX
				right_side_no = n;							// El

				cli();
				write_eep_right_side_no(right_side_no);		// ddoqnl El 
				sei();										// 荞݉
			}
			led_ds1_off();
			break;
		}

		set_bright();											// 邳߂
	}
}
// *****************************
// \ʒu̐ݒ菈
// *****************************
static	void	setpro_pos(void)
{
	unsigned char	n;
	unsigned char	blink=0;
	unsigned char	uc = 0;

	tim_10ms_blink = 50;									// 500mS Ԋu
	tim_1s_next = 5;										// 5S Ԋu
	n = target_number;
	asc_to_dotmatrix(n+'0',0,0);							// AXL[hbg}gbNXf[^ɕϊ

	while(1){
		if(tim_10ms_blink == 0){
			tim_10ms_blink = 50;							// 500mS Ԋu
			blink ^= 1;
			if(blink == 0){
				asc_to_dotmatrix(' ',0,0);					// AXL[hbg}gbNXf[^ɕϊiXy[Xj
			}else{
				asc_to_dotmatrix(n+'0',0,0);				// AXL[hbg}gbNXf[^ɕϊij
			}
		}

		if(tim_1s_next == 0){
			tim_1s_next = 5;								// 5S Ԋu
			if(uc & SW1_ON){								// XCb`͉Ă
				;											// l͂̂܂
			}else{
				n++;										// ̐l
				if(10 <= n){
					n = 0;
				}
				asc_to_dotmatrix(n+'0',0,0);				// AXL[hbg}gbNXf[^ɕϊij
				blink = 1;
			}
		}

		uc = get_action_sw();								// XCb`̏
		if(uc & SW1_ON_NOW){								// ꂽ
			led_ds2_on();									// LED2 ON
		}
		if(uc & SW1_OFF_SHORT){								// Zꂽ
			led_ds2_off();
			break;
		}else if(uc & SW1_OFF_LONG){						// ꂽ
			asc_to_dotmatrix(n+'0',0,0);					// AXL[hbg}gbNXf[^ɕϊij
			if(target_number != n){							// ԍύX
				target_number = n;							// ԍ

				cli();
				write_eep_target_no(target_number);			// ddoqnl \Ԗ 
				sei();										// 荞݉
			}
			led_ds2_off();
			break;
		}

		set_bright();											// 邳߂
	}
}
// *****************************
// ʐMaor̐ݒ菈
// *****************************
static	void	setpro_bps(void)
{
	unsigned char	n;
	unsigned char	blink=0;
	unsigned char	uc=0;

	tim_10ms_blink = 50;									// 500mS Ԋu
	tim_1s_next = 5;										// 5S Ԋu
	n = bps_character;
	asc_to_dotmatrix(n,0,0);								// AXL[hbg}gbNXf[^ɕϊ

	while(1){
		if(tim_10ms_blink == 0){
			tim_10ms_blink = 50;							// 500mS Ԋu
			blink ^= 1;
			if(blink == 0){
				asc_to_dotmatrix(' ',0,0);					// AXL[hbg}gbNXf[^ɕϊiXy[Xj
			}else{
				asc_to_dotmatrix(n,0,0);					// AXL[hbg}gbNXf[^ɕϊij
			}
		}

		if(tim_1s_next == 0){
			tim_1s_next = 5;								// 5S Ԋu
			if(uc & SW1_ON){								// XCb`͉Ă
				;											// ͂̂܂
			}else{
				n++;										//  ̕
				if('E' < n){
					n = 'A';
				}

				asc_to_dotmatrix(n,0,0);					// AXL[hbg}gbNXf[^ɕϊij
				blink = 1;
			}
		}

		uc = get_action_sw();								// XCb`̏
		if(uc & SW1_ON_NOW){								// ꂽ
			led_ds2_on();									// LED2 ON
		}
		if(uc & SW1_OFF_SHORT){								// Zꂽ
			led_ds2_off();
			break;
		}else if(uc & SW1_OFF_LONG){						// ꂽ
			asc_to_dotmatrix(n,0,0);						// AXL[hbg}gbNXf[^ɕϊij
			if(bps_character != n){							// ύX
				bps_character = n;							// 

				cli();
				write_eep_char_bps(bps_character);			// ddoqnl BPS CHAR 
				sei();										// 荞݉

			}
			led_ds2_off();
			break;
		}

		set_bright();											// 邳߂
	}
}
// *****************************
// f~^iZp[^j̐ݒ菈
// *****************************
static	void	setpro_delimiter(void)
{
	unsigned char	n;
	unsigned char	blink=0;
	unsigned char	uc=0;

	tim_10ms_blink = 50;									// 500mS Ԋu
	tim_1s_next = 5;										// 5S Ԋu
	n = delimiter_cord;
	asc_to_dotmatrix(n,0,0);								// AXL[hbg}gbNXf[^ɕϊ

	while(1){
		if(tim_10ms_blink == 0){
			tim_10ms_blink = 50;							// 500mS Ԋu
			blink ^= 1;
			if(blink == 0){
				asc_to_dotmatrix(' ',0,0);					// AXL[hbg}gbNXf[^ɕϊiXy[Xj
			}else{
				asc_to_dotmatrix(n,0,0);					// AXL[hbg}gbNXf[^ɕϊij
			}
		}

		if(tim_1s_next == 0){
			tim_1s_next = 5;								// 5mS Ԋu
			if(uc & SW1_ON){								// XCb`͉Ă
				;											// R[h͂̂܂
			}else{
				if(n == 0x0d){								//  ̃R[h
					n = 0x0a;
				}else{
					n = 0x0d;
				}
				asc_to_dotmatrix(n,0,0);					// AXL[hbg}gbNXf[^ɕϊij
				blink = 1;
			}
		}

		uc = get_action_sw();								// XCb`̏
		if(uc & SW1_ON_NOW){								// ꂽ
			led_ds2_on();									// LED2 ON
		}
		if(uc & SW1_OFF_SHORT){								// Zꂽ
			led_ds2_off();
			break;
		}else if(uc & SW1_OFF_LONG){						// ꂽ
			asc_to_dotmatrix(n,0,0);						// AXL[hbg}gbNXf[^ɕϊij
			if(delimiter_cord != n){						// ύX
				delimiter_cord = n;							// 

				cli();
				write_eep_delimiter(delimiter_cord);		// ddoqnl ʐMf~^ 
				sei();										// 荞݉

			}
			led_ds2_off();
			break;
		}

		set_bright();											// 邳߂
	}
}

// *****************************
// ݒ菈
// *****************************
void	setpro(void)
{

	led_ds2_off();
	led_ds1_on();
	sw_init();								// XCb`֌W̏ݒ

//20230125	wait_sw_off();							// XCb`܂ő҂

// 20230125------
	uart_init_trx(1);						// UART ݒ M
	while(1){
		delay_ms(100);						// 100mS Delay
		if((~SW_PORT & (SW1_ON_BIT)) == 0){	// select switch & set switch
			delay_ms(50);						// 50mS Delay
			if((~SW_PORT & (SW1_ON_BIT)) == 0){	// select switch & set switch
				break;							// {ɗꂽƂ
			}
		}
		uart_tx_one(bps_character);
		led_ds1_toggle();					//  LED1 Toggle
	}
	uart_close();
// -------20230125

	led_ds1_off();

	asc_to_dotmatrix(' ',0,0);				// AXL[hbg}gbNXf[^ɕϊ
	timer2_init();							// Timer2 ݒ
	sei();									// 荞݉

	while(1){
		setpro_pos();						// \ʒu̐ݒ菈
		setpro_bps();						// ʐMaor̐ݒ菈
		setpro_delimiter();					// f~^iZp[^j̐ݒ菈
		setpro_right_side_no();				// El̐ݒ菈
		setpro_mirror_touritu();			// A|̐ݒ菈
	}
}

